<?php
/* Teqtop */
defined('_JEXEC') or die('Restricted access');

class plgcontentggpkg_importInstallerScript
{
	public function addLogger()
	{
		$option = array(
				'format'	=> '{DATE}\t{TIME}\t{LEVEL}: {MESSAGE}',
				'text_file' => 'ggsw_log.txt',
				'logger'	=> 'formattedtext');
		JLog::addLogger($option);
	}
	
	function install($parent)
	{
		$this->addLogger();
		$db = JFactory::getDbo();
		$db1 = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		$query	->select(array('params'))
				->from('#__extensions')
				->where('name=\'com_media\'');
		
		$db->setQuery($query);
		$result = $db->loadAssoc();
		
		$json = json_decode($result['params']);
		$ignore_extensions = $json->{'ignore_extensions'};
		if (JString::strlen($ignore_extensions)>0)
			$ignore_extensions .= ",";
		$ignore_extensions .= "ggpkg,GGPKG";
		$json->{'ignore_extensions'} = $ignore_extensions;
		
		// update db
		$query = $db->getQuery(true);
		$json_string = json_encode($json);

		$fields = array('params=\'' . $json_string . '\'');
		$conditions = array('name=\'com_media\'');
		
		$query	->update($db->quoteName('#__extensions'))
				->set($fields)
				->where($conditions);
		
		$db->setQuery($query);
		

		try {
			$result = $db->query(); // Use $db->execute() for Joomla 3.0.
			$query1 = "UPDATE `#__extensions` SET enabled ='1' WHERE element='ggpkg_import'";
			$db1->setQuery( $query1 );
			$db1->query();
		} catch (Exception $e) {
			JLog::add("DB Update (install) not successful!", JLog::CRITICAL);
		}			
	}

	/*function update($parent)
	{

		$ggpkgPath = JPATH_ROOT . "/media/ggpkg";

		system("rm -rf ".escapeshellarg($ggpkgPath));
		rmdir($ggpkgPath);		
	}*/
	
	function postflight($type, $parent)
	{
		$this->addLogger();
		
		if ($type == "install")
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			
			$fields = array('enabled=1');
			$conditions = array('name=\'GGPKG Import\'');
			
			$query	->update($db->quoteName('#__extensions'))
					->set($fields)
					->where($conditions);
			
			$db->setQuery($query);
			
			try {
				$result = $db->query(); // Use $db->execute() for Joomla 3.0.
			} catch (Exception $e) {
				JLog::add("DB Update (postflight) not successful!", JLog::CRITICAL);
			}			
		}	
	}
	
	function uninstall($parent)
	{
		$this->addLogger();
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		$query	->select(array('params'))
		->from('#__extensions')
		->where('name=\'com_media\'');
		
		$db->setQuery($query);
		$result = $db->loadAssoc();
		
		$json = json_decode($result['params']);
		$ignore_extensions = $json->{'ignore_extensions'};
		
		if (JString::strpos($ignore_extensions, "ggpkg,GGPKG")!==false)
		{
			$ignore_extensions = JString::substr($ignore_extensions, 0, JString::strpos($ignore_extensions, "ggpkg,GGPKG")) . JString::substr($ignore_extensions, JString::strpos($ignore_extensions, "ggpkg,GGPKG")+11);
			$json->{'ignore_extensions'} = $ignore_extensions;
			
			// update db
			$query = $db->getQuery(true);
			$json_string = json_encode($json);
			
			$fields = array('params=\'' . $json_string . '\'');
			$conditions = array('name=\'com_media\'');
			
			$query	->update($db->quoteName('#__extensions'))
			->set($fields)
			->where($conditions);
			
			$db->setQuery($query);

			/*$ggpkgPath = JPATH_ROOT . "/media/ggpkg";

			system("rm -rf ".escapeshellarg($ggpkgPath));
			rmdir($ggpkgPath);*/
			
			try {
				$result = $db->query(); // Use $db->execute() for Joomla 3.0.
			} catch (Exception $e) {
				JLog::add("DB Update (uninstall) not successful!", JLog::CRITICAL);
			}
		}
	}
}